import java.awt.*;

import java.awt.event.*;

import java.awt.image.*;

import java.awt.geom.*;

import javax.swing.*;

import javax.swing.event.*;



// Files

import java.io.*;

import java.util.*;



class ButtonPanel extends JPanel implements ActionListener

{

     public ButtonPanel()

     {

         // grid bag layout



          GridBagLayout gbLayout = new GridBagLayout();

          GridBagConstraints constraints = new GridBagConstraints();

          setLayout( gbLayout );



          constraints.weightx = 100;

          constraints.weighty = 100;



          constraints.gridx = 0;

          constraints.gridy = 1;

          constraints.gridwidth = 1;

          constraints.gridheight = 1;

          add( placeButton, constraints );



          constraints.gridx = 2;

          constraints.gridy = 1;

          constraints.gridwidth = 1;

          constraints.gridheight = 1;

          add( removeButton, constraints );



          constraints.gridx = 4;

          constraints.gridy = 1;

          constraints.gridwidth = 1;

          constraints.gridheight = 1;

          add( zoomInButton, constraints );



          constraints.gridx = 6;

          constraints.gridy = 1;

          constraints.gridwidth = 1;

          constraints.gridheight = 1;

          add( zoomOutButton, constraints );

       



          // action listeners & mnemonics

          zoomInButton.addActionListener( this );

          zoomOutButton.addActionListener( this );

          placeButton.addActionListener( this );

          removeButton.addActionListener( this );



          zoomInButton.setMnemonic( 'I' );

          zoomOutButton.setMnemonic( 'O' );

          placeButton.setMnemonic( 'P' );

          removeButton.setMnemonic( 'R' );

     }



     // button handling routine

     public void actionPerformed( ActionEvent evt )

     {

          Object buttonPressed = evt.getSource();



          if ( buttonPressed == zoomInButton )

          {

               if ( sm.zoomFactor < 30.0 )

                    sm.zoomFactor = sm.zoomFactor * 2;

          }

          else if ( buttonPressed == zoomOutButton )

          {

               if ( sm.zoomFactor > 0.13 )

                    sm.zoomFactor = sm.zoomFactor / 2;

          }

          else if ( buttonPressed == placeButton )

          {

               sm.removePlant = false;

          }

          else if ( buttonPressed == removeButton )

          {

               sm.removePlant = true;

          }

     }





// buttons

     private JButton zoomInButton = new JButton("Zoom In");

     private JButton zoomOutButton = new JButton("Zoom Out");

     private JButton placeButton = new JButton("Place Plant");

     private JButton removeButton = new JButton("Remove Plant");



// dialogs

     private ScreenManager sm;



}



class MapPanel extends JPanel implements MouseListener, MouseMotionListener

{

	public MapPanel()

	{

		addMouseListener( this );

          addMouseMotionListener( this );

	

          image = new Image[ 9 ];

          image[ 0 ] = Toolkit.getDefaultToolkit().getImage("groundbigger.gif");

          image[ 1 ] = Toolkit.getDefaultToolkit().getImage("plant1.jpg");

          image[ 2 ] = Toolkit.getDefaultToolkit().getImage("plant2.jpg");

          image[ 3 ] = Toolkit.getDefaultToolkit().getImage("plant3.jpg");

          image[ 4 ] = Toolkit.getDefaultToolkit().getImage("plant4.jpg");

          image[ 5 ] = Toolkit.getDefaultToolkit().getImage("plant5.jpg");

          image[ 6 ] = Toolkit.getDefaultToolkit().getImage("plant6.jpg");

          image[ 7 ] = Toolkit.getDefaultToolkit().getImage("plant7.jpg");

          image[ 8 ] = Toolkit.getDefaultToolkit().getImage("plant8.jpg");

          

          Toolkit tk = Toolkit.getDefaultToolkit();

          Dimension d = tk.getScreenSize();



          sm.screenWidth = d.width;

          sm.screenHeight = d.height;

          sm.zoomFactor = 1d;

          sm.lhsXCoordinate = 100;

          sm.lhsYCoordinate = 0;



          setLayout( new BorderLayout() );

          add( statusBar, "South" );

          

          statusBar.setEditable( false );



          sm.plantNumber = 1;

	}



	public void mousePressed( MouseEvent evt )

	{

          int origX = evt.getX();

          int origY = evt.getY();



		Graphics g = getGraphics();

		String junk = new String();

          junk = "+";



          g.setColor( Color.red);

          g.drawString( junk, origX, origY );



          if ( sm.removePlant == false )

          {

                pm.addPlant();

                repaint();

          }

          else

          {

                pm.removePlant();

                repaint();

          }

	}



     public void mouseClicked( MouseEvent evt )

     {}



     public void mouseReleased( MouseEvent evt )

     {}



     public void mouseEntered( MouseEvent evt )

     {}



     public void mouseExited( MouseEvent evt )

     {}



     public void mouseMoved( MouseEvent evt )

     {

          Graphics g = getGraphics();



          if ( lastZoomFactor != sm.zoomFactor )

               repaint();



          tempX = evt.getX();

          tempY = evt.getY();



          if ( tempX <= 15  &&  sm.realCurrentX > MIN_X )

          {

               sm.lhsXCoordinate -= 200 / sm.zoomFactor;

               repaint();

          }

          else if ( tempX >= sm.screenWidth - 30  &&  sm.realCurrentX < MAX_X )

          {

               sm.lhsXCoordinate += 200 / sm.zoomFactor;

               repaint();

          }

          else if ( tempY <= 15  &&  sm.realCurrentY > MIN_Y)

          {

               sm.lhsYCoordinate -= 200 / sm.zoomFactor;

               repaint();

          }

          else if ( tempY >= sm.screenHeight - 130  &&  sm.realCurrentY <  MAX_Y)

          {

               sm.lhsYCoordinate += 200 / sm.zoomFactor;

               repaint();

          } 



          sm.realCurrentX = -1500 + sm.lhsXCoordinate + ( tempX / (int)sm.zoomFactor );

          sm.realCurrentY = -1500 + sm.lhsYCoordinate + ( tempY / (int)sm.zoomFactor );

          

          findSector();



          if ( sm.removePlant == false )

               status = "Plant: " + sm.plantNumber + "          ";

          else

               status = "[Remove Plant]" + "          ";



          status = status + "Zoom: " + ( sm.zoomFactor * 100 ) + "%          ";

          status = status + "Location: (" + sm.realCurrentX + ", " + sm.realCurrentY + ")          ";

          status = status + "Sector: " + sm.sector;



          sm.absCurrentX = sm.realCurrentX + 1500;

          sm.absCurrentY = sm.realCurrentY + 1500;



          statusBar.setText( status );

          lastZoomFactor = sm.zoomFactor;



     }



     public void mouseDragged( MouseEvent evt )

     {}



     public void paintComponent( Graphics graphics )

     {

          super.paintComponent( graphics );

          Vector drawIndicies = new Vector();

          Graphics2D g = (Graphics2D) graphics;

          int plantNum;

          int x;

          int y;



          AffineTransform aft = new AffineTransform();

          aft.scale( sm.zoomFactor, sm.zoomFactor );

          aft.translate( -sm.lhsXCoordinate, -sm.lhsYCoordinate );

          g.setTransform( aft );



          g.drawImage( image[ 0 ], 0, 0, 3000, 3000, this );



          pm.plantsToDraw();



          if ( sm.drawablePlantCount > 0 )

          {

               for ( int i = 0; i <= sm.drawablePlantCount; i++ )

               {

                    plantNum = sm.drawablePlants[ i ][ PLANT_NUM ];

                    x = sm.drawablePlants[ i ][ X_COORDINATE ] + 1500;

                    y = sm.drawablePlants[ i ][ Y_COORDINATE ] + 1500;

               

                    // change scale

                    g.drawImage( image[ plantNum ], x, y, 2, 2, this );

               }



          }  

     }



     public void findSector()

     {

          if ( sm.realCurrentX < -500 )

          {

               if ( sm.realCurrentY < -500 )

                    sm.sector = "NW";

               else if ( sm.realCurrentY < 500 )

                    sm.sector = "W";

               else if ( sm.realCurrentY <= 1500 )

                    sm.sector = "SW";

          }

          else if ( sm.realCurrentX < 500 )

          {

               if ( sm.realCurrentY < -500 )

                    sm.sector = "N";

               else if ( sm.realCurrentY < 500 )

                    sm.sector = "C";

               else if ( sm.realCurrentY <= 1500 )

                    sm.sector = "S";

          }

          else if ( sm.realCurrentX <= 1500 )

          {

               if ( sm.realCurrentY < -500 )

                    sm.sector = "NE";

               else if ( sm.realCurrentY < 500 )

                    sm.sector = "E";

               else if ( sm.realCurrentY <= 1500 )

                    sm.sector = "SE";

          }



     }





// attributes

     private PlantManager pm = new PlantManager();

     private ScreenManager sm;

     private String status = new String();

     private JTextField statusBar = new JTextField( 70 );

     double lastZoomFactor;

     int tempX;

     int tempY;



// images

     private Image[] image;



// constants

     private final int PLANT_NUM = 0;

     private final int X_COORDINATE = 1;

     private final int Y_COORDINATE = 2;

     private final int MIN_X = -1500;

     private final int MAX_X = 1500;

     private final int MIN_Y = -1500;

     private final int MAX_Y = 1500;



}



class CorrFrame extends JFrame implements ActionListener

{

     public CorrFrame()

     {

          Toolkit tk = Toolkit.getDefaultToolkit();

          Dimension d = tk.getScreenSize();

          sm.screenWidth = d.width;

          sm.screenHeight = d.height;

          sm.filename = "";



          setSize( sm.screenWidth, sm.screenHeight );

          setTitle("Correlations: Field Layout");

     

          addWindowListener( new WindowAdapter()

          {

               public void windowClosing( WindowEvent e )

               {

                    System.exit( 0 );               

               }

          } );



         createMenu();





         Container contentPane = getContentPane();

         contentPane.add( mapPanel, "Center" );

         contentPane.add( buttonPanel, "South" );

     }



     public void actionPerformed( ActionEvent evt )

     {

          String menuSelected = evt.getActionCommand();



          if ( menuSelected.equals( "New" ) )

          {

               int result = JOptionPane.showConfirmDialog( null,

                              "Are you sure you want to start a new layout?",

                              "New Layout", JOptionPane.OK_CANCEL_OPTION,

                              JOptionPane.WARNING_MESSAGE );



               if ( result == JOptionPane.OK_OPTION )

                    pm.newFile();

                            

          }

          else if ( menuSelected.equals( "Open" ) )

          {

               fileChooser.setCurrentDirectory( new File(".") );

               fileChooser.setMultiSelectionEnabled( false );

               int result = fileChooser.showOpenDialog( null );



               if ( result == JFileChooser.APPROVE_OPTION )

               {

                    sm.filename = fileChooser.getSelectedFile().getName();

                    pm.newFile();

                    try

                    {

                         pm.readFile();

                    }

                    catch( IOException e )

                    {

                         System.exit( 1 );

                    }



               }



          }

          else if ( menuSelected.equals( "Save As" ) )

          {

               fileChooser.setCurrentDirectory( new File(".") );

               fileChooser.setMultiSelectionEnabled( false );

               int result = fileChooser.showSaveDialog( null );



               if ( result == JFileChooser.APPROVE_OPTION )

               {

                    sm.filename = fileChooser.getSelectedFile().getName();



                    JOptionPane.showMessageDialog( null, "Because of a "+

                    "programing error, go to the operating system "+

                    "command line window, press a letter,\nand then press "+

                    "the enter key.This is because the program is "+

                    "erroneously expecting input.\n\nThe programmer "+

                    "apologizes for this inconvenience.",

                    "Continuing Operation", JOptionPane.INFORMATION_MESSAGE );



                    try

                    {

                         pm.writeFile();

                    }

                     catch( IOException e )

                     {

                         System.exit( 1 );

                     }



               }

          }

          else if ( menuSelected.equals( "Exit" ) )

          {

               int result = JOptionPane.showConfirmDialog( null,

                              "Are you sure you want to quit?",

                              "Quit", JOptionPane.OK_CANCEL_OPTION,

                              JOptionPane.WARNING_MESSAGE );



               if ( result == JFileChooser.APPROVE_OPTION )

                    System.exit( 0 );               

          }

          else if ( menuSelected.equals( "Plant 1" ) )

          {

               sm.plantNumber = 1;

          }

          else if ( menuSelected.equals( "Plant 2" ) )

          {

               sm.plantNumber = 2;

          }

          else if ( menuSelected.equals( "Plant 3" ) )

          {

               sm.plantNumber = 3;

          }

          else if ( menuSelected.equals( "Plant 4" ) )

          {

               sm.plantNumber = 4;

          }

          else if ( menuSelected.equals( "Plant 5" ) )

          {

               sm.plantNumber = 5;

          }

          else if ( menuSelected.equals( "Plant 6" ) )

          {

               sm.plantNumber = 6;

          }

          else if ( menuSelected.equals( "Plant 7" ) )

          {

               sm.plantNumber = 7;

          }

          else if ( menuSelected.equals( "Plant 8" ) )

          {

               sm.plantNumber = 8;

          }

          else if ( menuSelected.equals( "Using this program" ) )

          {

               JOptionPane.showMessageDialog( null, "For information "+

                    "about how to use this program,\nopen the README.TXT "+

                    "file in the directory of this program.",

                    "Help", JOptionPane.INFORMATION_MESSAGE );



          }



     }



     public void menuDeselected( MenuEvent evt )

     {

          mapPanel.repaint();

     }





     public void createMenu()

     {

          fileMenu.add( fileNew );

          fileMenu.add( fileOpen );

          fileMenu.add( fileSaveAs );

          fileMenu.add( fileSeparator );

          fileMenu.add( fileExit );

          fileMenu.setMnemonic( 'F' );

          fileNew.addActionListener( this );

          fileOpen.addActionListener( this );

          fileSaveAs.addActionListener( this );

          fileExit.addActionListener( this );

          



          plantMenu.add( plant1Item );

          plantMenu.add( plant2Item );

          plantMenu.add( plant3Item );

          plantMenu.add( plant4Item );

          plantMenu.add( plant5Item );

          plantMenu.add( plant6Item );

          plantMenu.add( plant7Item );

          plantMenu.add( plant8Item );

          plantMenu.setMnemonic( 'T' );

          plant1Item.addActionListener( this );

          plant2Item.addActionListener( this );

          plant3Item.addActionListener( this );

          plant4Item.addActionListener( this );

          plant5Item.addActionListener( this );

          plant6Item.addActionListener( this );

          plant7Item.addActionListener( this );

          plant8Item.addActionListener( this );



          helpMenu.add( helpUsing );

          helpMenu.setMnemonic( 'H' );

          helpUsing.addActionListener( this );



          menuBar.add(fileMenu);

          menuBar.add(plantMenu);

          menuBar.add(helpMenu);



          setJMenuBar(menuBar);

     }





// file

     private JFileChooser fileChooser = new JFileChooser();





// components

     private JPanel mapPanel = new MapPanel();

     private JPanel buttonPanel = new ButtonPanel();



     private JMenuBar menuBar = new JMenuBar();

     private JMenu fileMenu = new JMenu("File");

     private JMenuItem fileNew = new JMenuItem("New", 'N');

     private JMenuItem fileOpen = new JMenuItem("Open", 'O');

     private JMenuItem fileSaveAs = new JMenuItem("Save As", 'S');

     private JSeparator fileSeparator = new JSeparator();

     private JMenuItem fileExit = new JMenuItem("Exit", 'X');



     private JMenu plantMenu = new JMenu("Plant");

     private JMenuItem plant1Item = new JMenuItem("Plant 1", '1');

     private JMenuItem plant2Item = new JMenuItem("Plant 2", '2');

     private JMenuItem plant3Item = new JMenuItem("Plant 3", '3');

     private JMenuItem plant4Item = new JMenuItem("Plant 4", '4');

     private JMenuItem plant5Item = new JMenuItem("Plant 5", '5');

     private JMenuItem plant6Item = new JMenuItem("Plant 6", '6');

     private JMenuItem plant7Item = new JMenuItem("Plant 7", '7');

     private JMenuItem plant8Item = new JMenuItem("Plant 8", '8');



     private JMenu helpMenu = new JMenu("Help");

     private JMenuItem helpUsing = new JMenuItem("Using this program", 'U' );



     

     private ScreenManager sm;

     private PlantManager pm = new PlantManager();



}



// somewhere in this file there might have been code adapted

// from Core Java 1.2 p.519





public class Corrlayout

{

     public static void main( String[] args )

     {

          JFrame frame = new CorrFrame();

          frame.show();



          

     }

}                                                                      

