import java.io.*;

import java.util.*;

import java.text.*;



public class PlantManager

{

     public PlantManager()

     {

          sortedPlantIndex = new TreeMap();



          sm.addFromFile = false;

          sm.plantTable = new int[ MAX_PLANT_COUNT ][ 6 ];

          plantCount = -1;



          for ( int i = 0; i < MAX_PLANT_COUNT; i++ )          

                 sm.plantTable[ i ][ OK_TO_DELETE ] = 1;

                              



          availableIndex = 0;



          sm.drawablePlants = new int[ MAX_PLANT_COUNT ][ 3 ];

          sm.drawablePlantCount = 0;

     }



     public boolean addPlant()

     {

          int randomRotation;

          int keyNum;

          int startX;

          int startY;

          boolean addedPlant;

          String xKey = new String();

          String yKey = new String();

          String xyKey = new String();



          if ( plantCount < MAX_PLANT_COUNT )

          {

               if ( sm.addFromFile == false )

               {

                    randomRotation = (int) (java.lang.Math.random() * 360);

               }

               else

                    randomRotation = sm.randomRotation;



               xKey = keyPart.format( sm.absCurrentX );

               yKey = keyPart.format( sm.absCurrentY );

               xyKey = xKey + yKey;



               sortedPlantIndex.put( new String( xyKey ), new Integer( availableIndex ) );





               plantCount++;

               sm.plantTable[ availableIndex ][ SECTOR ] = stringSector2Num( sm.sector );

               sm.plantTable[ availableIndex ][ PLANT_NUM ] = sm.plantNumber;

               sm.plantTable[ availableIndex ][ X_COORDINATE ] = sm.realCurrentX;

               sm.plantTable[ availableIndex ][ Y_COORDINATE ] = sm.realCurrentY;

               sm.plantTable[ availableIndex ][ Y_ROTATION ] = randomRotation;

               sm.plantTable[ availableIndex ][ OK_TO_DELETE ] = 0;



               findNextIndex();

               addedPlant = true;

          }



          else

          {

               addedPlant = false;

          }



          return addedPlant;

     }



     public void removePlant()

     {

          int keyNum;

          int index;

          String xKey = new String();

          String yKey = new String();

          String xyKey = new String();



          xKey = keyPart.format( sm.absCurrentX );

          yKey = keyPart.format( sm.absCurrentY );

          xyKey = xKey + yKey;



          if ( sortedPlantIndex.containsKey( new String( xyKey ) ) )

          {

               index = ( (Integer) sortedPlantIndex.get( new String( xyKey ) ) ).intValue(); 

                                        

               sortedPlantIndex.remove( new String( xyKey ) );

               plantCount--;



               sm.plantTable[ index ][ OK_TO_DELETE ] = 1;

               availableIndex = index;

          }



          // else ignore



     }



     public void newFile()

     {

          for ( int i = 0; i < MAX_PLANT_COUNT; i++ )          

               sm.plantTable[ availableIndex ][ OK_TO_DELETE ] = 1;



          sortedPlantIndex.clear();

          sm.drawablePlantCount = 0;

     }



     public void writeFile() throws IOException

     {

          BufferedReader br = new BufferedReader( new InputStreamReader(System.in));

          fileOut = new PrintWriter( new FileWriter( sm.filename ) );

          String[] line = new String[ 4 ];

          int index;



          try

          {

               for ( index = 1; index < MAX_PLANT_COUNT; index++ )

               {

                    if ( sm.plantTable[ index ][ OK_TO_DELETE ] == 0 )

                    {

                         line[ 0 ] = NAME + numSector2String( sm.plantTable[ index ][ SECTOR ] ) + ' ' +

                                        PLANT + index;



                         line[ 1 ] = INVENTOR_FILE + PLANT + '_' +

                                        sm.plantTable[ index ][ PLANT_NUM ] + PFB;



                         line[ 2 ] = TRANSLATE + sm.plantTable[ index ][ X_COORDINATE ] +

                                        ' ' + sm.plantTable[ index ][ Y_COORDINATE ];



                         line[ 3 ] = ROTATE_Y + sm.plantTable[ index ][ Y_ROTATION ];

          

                         for ( int lineIndex = 0; lineIndex < 4; lineIndex++ )

                         {

                              fileOut.println( line[ lineIndex ] );                             

                         }



                         fileOut.println();

                   }

               }

                   

              fileOut.close();

              System.out.println("Please press a letter and press the enter key.");

              br.readLine();               

          }

          catch( IOException e )

          {

               System.out.print("Error: " + e);

               System.exit( 1 );

          }

     }



     public void readFile() throws IOException

     {

          fileIn = new BufferedReader( new FileReader( sm.filename ) );

          sm.addFromFile = true;



          // while loop from Core Java 1.2 p. 645

      

          try

          {

               BufferedReader br = new BufferedReader( new InputStreamReader(System.in));

               String[] line = new String[ 5 ];

               String stringNum = new String();

               String temp = new String();

               String xKey = new String();

               String yKey = new String();

               String xyKey = new String();

               int absX;

               int absY;

               int temp2;



               char charDigit;



               int index;

               boolean flagEOF;



               plantCount = 0;



               do

                {

                    line[ 0 ] = fileIn.readLine();

                    line[ 1 ] = fileIn.readLine();

                    line[ 2 ] = fileIn.readLine();

                    line[ 3 ] = fileIn.readLine();



                    StringTokenizer tokenLine1 = new StringTokenizer( line[ 0 ] );

                    StringTokenizer tokenLine2 = new StringTokenizer( line[ 1 ] );

                    StringTokenizer tokenLine3 = new StringTokenizer( line[ 2 ] );

                    StringTokenizer tokenLine4 = new StringTokenizer( line[ 3 ] );



               



                    // line 1

                    tokenLine1.nextToken();                   // ignore NAME

                    temp = tokenLine1.nextToken();            // sector



                    stringNum = tokenLine1.nextToken();          // plantID

                    stringNum = "0"+stringNum.substring( 5, stringNum.length() );

                    index = Integer.parseInt( stringNum );



                    sm.plantTable[ index ][ SECTOR ] = stringSector2Num( temp );  //sector num

                    





                    // line 2

                    tokenLine2.nextToken();                   // ignore INVENTOR_FILE

                    stringNum = tokenLine2.nextToken();            // PLANT_NUM token

                    stringNum = "0"+stringNum.charAt( 6 );          // PLANT_NUM digit

                    sm.plantNumber = Integer.parseInt( stringNum );

               

                    // line 3

                    tokenLine3.nextToken();            // ignore TRANSLATE

                    stringNum = tokenLine3.nextToken();

                    sm.realCurrentX = Integer.parseInt( stringNum );



                    stringNum = tokenLine3.nextToken();

                    sm.realCurrentY = Integer.parseInt( stringNum );





                    // line 4

                    tokenLine4.nextToken();       // ignore ROTATE_Y

                    stringNum = tokenLine4.nextToken();

                    sm.randomRotation = Integer.parseInt( stringNum );





                    sm.absCurrentX = sm.realCurrentX + 1500;

                    sm.absCurrentY = sm.realCurrentY + 1500;



                    plantCount++;



                    addPlant();



               }

               while ( ( line[ 4 ] = fileIn.readLine() ) != null );



               fileIn.close();

          }



          catch( IOException e )

          {

               System.out.print("Error: " + e);

               System.exit( 1 );

          }

               

     }





     public void plantsToDraw() 

     {

          int xEnd;

          int yEnd;

          int xStart;

          int yStart;

          int value;

          int index;

          int numStartCorner;

          int numEndCorner;



          int[] tempArray;

          String thisValue = new String();

          String stringIndex = new String();

          String x1Key = new String();

          String y1Key = new String();

          String x2Key = new String();

          String y2Key = new String();

          String startCorner = new String();

          String endCorner = new String();

          int gt0;

          int lt0;



          sm.drawablePlants = new int[ MAX_PLANT_COUNT + 1 ][ 3 ];



          // already absolute coordinates

          xStart = sm.lhsXCoordinate;

          yStart = sm.lhsYCoordinate;



          // calculate viewable area

          xEnd = (int) Math.round( ( xStart + sm.screenWidth ) / sm.zoomFactor );

          yEnd = (int) Math.round( ( yStart + sm.screenHeight ) / sm.zoomFactor );



          x1Key = keyPart.format( xStart );

          x2Key = keyPart.format( xEnd );

          y1Key = keyPart.format( yStart );

          y2Key = keyPart.format( yEnd );



          startCorner = x1Key + y1Key;

          endCorner = x2Key + y2Key;



          // from Java 2 Unleashed p. 285-6 with adaptions



          // find what to draw

          Set keySet = sortedPlantIndex.keySet();

          Iterator keyIterator = keySet.iterator();

          Object keyObject;



          Collection valueCollection = sortedPlantIndex.values();

          Iterator valueIterator = valueCollection.iterator();

          Object valueObject;



          sm.drawablePlantCount = 0;



          while( keyIterator.hasNext() )

          {

               keyObject = keyIterator.next();

               valueObject = valueIterator.next();



               thisValue = keyObject.toString();



               index = ( (Integer) valueObject ).intValue();

               sm.drawablePlants[ sm.drawablePlantCount ][ 0 ] = sm.plantTable[ index ][ PLANT_NUM ];



               //need absolute coordinates and already have abs coords!

               sm.drawablePlants[ sm.drawablePlantCount ][ 1 ] = sm.plantTable[ index ][ X_COORDINATE ];

               sm.drawablePlants[ sm.drawablePlantCount ][ 2 ] = sm.plantTable[ index ][ Y_COORDINATE ];

               sm.drawablePlantCount++;

          }



     }





     private void findNextIndex()

     {

          boolean found = false;

          int index = 0;



          while ( index < MAX_PLANT_COUNT - 1  &&  found == false )

          {

               if ( sm.plantTable[ index ][ OK_TO_DELETE ] == 1 )

               {



                    found = true;

               }

               else

               {

                    index++;

               }

          }



          availableIndex = index;          

     }



     private String numSector2String( int sectorNum )

     {

          String name = new String();



          switch( sectorNum )

          {

               case 1:

                    name = "NW";

                    break;



               case 2:

                    name = "N";

                    break;



               case 3:

                    name = "NE";

                    break;



               case 4:

                    name = "W";

                    break;



               case 5:

                    name = "C";

                    break;



               case 6:

                    name = "E";

                    break;



               case 7:

                    name = "SW";

                    break;



               case 8:

                    name = "S";

                    break;



               case 9:

                    name = "SE";

                    break;



               default:

                    break;

          }



          return name;

     }



     private int stringSector2Num( String stringSector )

     {

          int sectorNum = 0;



          if ( stringSector.equals( "NW" ) )

               sectorNum = 1;

          else if ( stringSector.equals( "N" ) )

               sectorNum = 2;

          else if ( stringSector.equals( "NE" ) )

               sectorNum = 3;

          else if ( stringSector.equals( "W" ) )

               sectorNum = 4;

          else if ( stringSector.equals( "C" ) )

               sectorNum = 5;

          else if ( stringSector.equals( "E" ) )

               sectorNum = 6;

          else if ( stringSector.equals( "SW" ) )

               sectorNum = 7;

          else if ( stringSector.equals( "S" ) )

               sectorNum = 8;

          else if ( stringSector.equals( "SE" ) )

               sectorNum = 9;

     

          return sectorNum;

     }





// class attributes

     private DecimalFormat keyPart = new DecimalFormat("0000");

     public static TreeMap sortedPlantIndex;

     private BufferedReader fileIn;

     private PrintWriter fileOut;

     public static int plantCount;

     public static int availableIndex;



     private ScreenManager sm;



// array index constants

     private final int SECTOR = 0;

     private final int PLANT_NUM = 1;

     private final int X_COORDINATE = 2;

     private final int Y_COORDINATE = 3;

     private final int Y_ROTATION = 4;

     private final int OK_TO_DELETE = 5;



// constants

     private final int MAX_PLANT_COUNT = 750;

     private final String NAME = new String ("NAME ");

     private final String PLANT = new String ("plant");

     private final String INVENTOR_FILE = new String ("INVENTOR_FILE ");

     private final String PFB = new String (".pfb");

     private final String TRANSLATE = new String ("TRANSLATE ");

     private final String ROTATE_Y = new String ("ROTATE_Y ");

}

